/***************************************************************************
                Replicate Work Class
                -----------------------------------------
    begin      : 2012/10/14
    copyright  : (C) 2010 SolutionBox Inc.
    author     : Service 1 Team
    email      : svc1@solbox.com
    version    : 1.0

    CopyRight(C) 2010 SolutionBox Inc. All Rights reserved.
    Redistribution and use in source and binary forms, with or with out
    modification, are not permitted in outside of SolutionBox Inc.
***************************************************************************/

#ifndef __CASH_GENERATOR_H__
#define __CASH_GENERATOR_H__

#include <pthread.h>
#include <string>
#include <map>
#include "Logger.h"
#include "Database.h"
#include "FimngdData.h"
#include "CacheRequestList.h"
#include "SharedMemAPR.h"

/// @brief
class CCacheGeneratorThread
{
public:
	/// @brief 생성자
	CCacheGeneratorThread();
	~CCacheGeneratorThread();
	
	/// @brief Thread를 생성하고, 이를 시작한다.
	/// @param none
	/// @return 성공은 return true 실패는 return false
	bool Start();
	
	/// @brief ProcessStatus 내의 RCDB 관련 설정값을 이용해 DB Connection을 한다.
	/// @param sighandle 쓰레드에서 signal에 따라 정상 종료하도록 signal handle을 전달한다.
	/// @param pshmemNetworStat 공유메모리 포인터
	/// @return 성공하면 return true 실패하면 return false
	bool ThreadInit(const sig_atomic_t *sighandle);

	CCacheRequestList * GetReqList() { return &m_cacheReqList; }

// Attributes
private:
	// 쓰레드 핸들
	pthread_t m_threadHandle;
	
	const sig_atomic_t *m_sighandle;

	CCacheRequestList m_cacheReqList;

	// rc_rmcd host & port info
	std::string m_szHost;
	int m_nPort;

	// 쓰레드 시작 루틴이다.
	static void* EntryPoint(void* arg);
	
	// 해당 함수의 내용은 수정하지 말것.
	void Execute();

	// rc_rmcd로 internal cache를 요청한다.
	bool Request();
	uint64_t GetFileSize(std::string szFileName);

};
#endif //__CASH_GENERATOR_H__
